diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-mode.h ns-3.34/src/wifi/model/wifi-mode.h
--- ns-3.33/src/wifi/model/wifi-mode.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-mode.h	2021-07-14 10:31:07.000000000 -0700
@@ -22,8 +22,10 @@
 #ifndef WIFI_MODE_H
 #define WIFI_MODE_H
 
-#include <vector>
+#include "wifi-phy-common.h"
 #include "ns3/attribute-helper.h"
+#include "ns3/callback.h"
+#include <vector>
 
 namespace ns3 {
 
@@ -32,60 +34,6 @@
 class WifiTxVector;
 
 /**
- * This enumeration defines the modulation classes per
- * (Table 9-4 "Modulation classes"; IEEE 802.11-2012).
- */
-enum WifiModulationClass
-{
-  /** Modulation class unknown or unspecified. A WifiMode with this
-  WifiModulationClass has not been properly initialised. */
-  WIFI_MOD_CLASS_UNKNOWN = 0,
-  /** Infrared (IR) (Clause 16) */
-  WIFI_MOD_CLASS_IR,
-  /** Frequency-hopping spread spectrum (FHSS) PHY (Clause 14) */
-  WIFI_MOD_CLASS_FHSS,
-  /** DSSS PHY (Clause 15) */
-  WIFI_MOD_CLASS_DSSS,
-  /** HR/DSSS PHY (Clause 18) */
-  WIFI_MOD_CLASS_HR_DSSS,
-  /** ERP-PBCC PHY (19.6) */
-  WIFI_MOD_CLASS_ERP_PBCC,
-  /** DSSS-OFDM PHY (19.7) */
-  WIFI_MOD_CLASS_DSSS_OFDM,
-  /** ERP-OFDM PHY (19.5) */
-  WIFI_MOD_CLASS_ERP_OFDM,
-  /** OFDM PHY (Clause 17) */
-  WIFI_MOD_CLASS_OFDM,
-  /** HT PHY (Clause 20) */
-  WIFI_MOD_CLASS_HT,
-  /** VHT PHY (Clause 22) */
-  WIFI_MOD_CLASS_VHT,
-  /** HE PHY (Clause 26) */
-  WIFI_MOD_CLASS_HE
-};
-
-/**
- * This enumeration defines the various convolutional coding rates
- * used for the OFDM transmission modes in the IEEE 802.11
- * standard. DSSS (for example) rates which do not have an explicit
- * coding stage in their generation should have this parameter set to
- * WIFI_CODE_RATE_UNDEFINED.
- */
-enum WifiCodeRate
-{
-  /** No explicit coding (e.g., DSSS rates) */
-  WIFI_CODE_RATE_UNDEFINED,
-  /** Rate 3/4 */
-  WIFI_CODE_RATE_3_4,
-  /** Rate 2/3 */
-  WIFI_CODE_RATE_2_3,
-  /** Rate 1/2 */
-  WIFI_CODE_RATE_1_2,
-  /** Rate 5/6 */
-  WIFI_CODE_RATE_5_6
-};
-
-/**
  * \brief represent a single transmission mode
  * \ingroup wifi
  *
@@ -119,14 +67,21 @@
    */
   uint64_t GetPhyRate (uint16_t channelWidth, uint16_t guardInterval, uint8_t nss) const;
   /**
-   * \param txVector the WifiTxVector of the signal
+   * \param txVector the const WifiTxVector& of the signal
+   * \param staId the station ID for MU (unused if SU)
    *
    * \returns the physical bit rate of this signal in bps.
    *
    * If a transmission mode uses 1/2 FEC, and if its
    * data rate is 3.25Mbps, the PHY rate is 6.5Mbps
    */
-  uint64_t GetPhyRate (WifiTxVector txVector) const;
+  uint64_t GetPhyRate (const WifiTxVector& txVector, uint16_t staId = SU_STA_ID) const;
+  /**
+   * \param channelWidth the considered channel width in MHz
+   *
+   * \returns the physical bit rate of this non-HT signal.
+  */
+  uint64_t GetPhyRate (uint16_t channelWidth) const;
   /**
    *
    * \param channelWidth the considered channel width in MHz
@@ -137,16 +92,16 @@
    */
   uint64_t GetDataRate (uint16_t channelWidth, uint16_t guardInterval, uint8_t nss) const;
   /**
-   * \param txVector the WifiTxVector of the signal
+   * \param txVector the const WifiTxVector& of the signal
    * \param staId the station ID for MU (unused if SU)
    *
    * \returns the data bit rate of this signal.
    */
-  uint64_t GetDataRate (WifiTxVector txVector, uint16_t staId = SU_STA_ID) const;
+  uint64_t GetDataRate (const WifiTxVector& txVector, uint16_t staId = SU_STA_ID) const;
   /**
    * \param channelWidth the considered channel width in MHz
    *
-   * \returns the data bit rate of this non-HT or non-VHT signal.
+   * \returns the data bit rate of this non-HT.
   */
   uint64_t GetDataRate (uint16_t channelWidth) const;
 
@@ -246,6 +201,18 @@
  *         false otherwise
  */
 bool operator == (const WifiMode &a, const WifiMode &b);
+
+/**
+ * Check if the two WifiModes are different.
+ *
+ * \param a WifiMode
+ * \param b WifiMode
+ *
+ * \return true if the two WifiModes are different,
+ *         false otherwise
+ */
+bool operator != (const WifiMode &a, const WifiMode &b);
+
 /**
  * Compare two WifiModes
  *
@@ -256,6 +223,7 @@
  *         false otherwise
  */
 bool operator < (const WifiMode &a, const WifiMode &b);
+
 /**
  * Serialize WifiMode to ostream (human-readable).
  *
@@ -298,17 +266,96 @@
 class WifiModeFactory
 {
 public:
+  // Typedefs for callbacks used by WifiModeItem
+  /**
+   * Typedef for callback used to retrieve code rate of a WifiMode
+   * \return the code rate of the WifiMode.
+   */
+  typedef Callback<WifiCodeRate> CodeRateCallback;
+  /**
+   * Typedef for callback used to retrieve constellation size of a WifiMode
+   * \return the size of modulation constellation of the WifiMode.
+   */
+  typedef Callback<uint16_t> ConstellationSizeCallback;
+  /**
+   * Typedef for callback used to calculate PHY rate of a WifiMode
+   *
+   * \param channelWidth the channel width in MHz
+   * \param guardInterval the guard interval duration in nanoseconds
+   * \param nss the number of streams
+   * \return the physical bit rate of the signal in bps.
+   */
+  typedef Callback<uint64_t, uint16_t /* channelWidth */, uint16_t /* guardInterval */, uint8_t /* nss */> PhyRateCallback;
+  /**
+   * Typedef for callback used to calculate PHY rate of a WifiMode
+   * from a TXVECTOR. This is mostly useful in HE or later amendments.
+   * For the others it's a simple wrapper of \see PhyRateCallback.
+   *
+   * \param txVector the TXVECTOR used for the transmission
+   * \param staId the station ID
+   * \return the physical bit rate of the signal in bps.
+   */
+  typedef Callback<uint64_t, const WifiTxVector& /* txVector */, uint16_t /* staId */> PhyRateFromTxVectorCallback;
+  /**
+   * Typedef for callback used to calculate data rate of a WifiMode
+   *
+   * \param channelWidth the channel width in MHz
+   * \param guardInterval the guard interval duration in nanoseconds
+   * \param nss the number of streams
+   * \return the data rate of the signal in bps.
+   */
+  typedef Callback<uint64_t, uint16_t /* channelWidth */, uint16_t /* guardInterval */, uint8_t /* nss */> DataRateCallback;
+  /**
+   * Typedef for callback used to calculate data rate of a WifiMode
+   * from a TXVECTOR. This is mostly useful in HE or later amendments.
+   * For the others it's a simple wrapper of \see DataRateCallback.
+   *
+   * \param txVector the TXVECTOR used for the transmission
+   * \param staId the station ID
+   * \return the data rate of the signal in bps.
+   */
+  typedef Callback<uint64_t, const WifiTxVector& /* txVector */, uint16_t /* staId */> DataRateFromTxVectorCallback;
+  /**
+   * Typedef for callback used to calculate Non-HT Reference Rate of
+   * an MCS defined in HT or later amendment. For Non-HT modes (DSSS, OFDM,
+   * etc) this should be defined as null.
+   *
+   * \return the rate (in bps) of the non-HT Reference Rate.
+   */
+  typedef Callback<uint64_t> NonHtReferenceRateCallback;
+  /**
+   * Typedef for callback used to check whether the combination of <current
+   * WifiMode, channel width (in MHz), number of stream> is allowed
+   *
+   * \param channelWidth the channel width in MHz
+   * \param nss the number of streams
+   * \return true if combination of current WifiMode and supplied parameters is allowed.
+   */
+  typedef Callback<bool, uint16_t /* channelWidth */, uint8_t /* nss */> ModeAllowedCallback;
+
   /**
    * \param uniqueName the name of the associated WifiMode. This name
    *        must be unique across _all_ instances.
    * \param modClass the class of modulation
    * \param isMandatory true if this WifiMode is mandatory, false otherwise.
-   * \param codingRate if convolutional coding is used for this rate
-   *        then this parameter specifies the convolutional coding rate
-   *        used. If there is no explicit convolutional coding step (e.g.,
-   *        for DSSS rates) then the caller should set this parameter to
-   *        WIFI_CODE_RATE_UNCODED.
-   * \param constellationSize the order of the constellation used.
+   * \param codeRateCallback a callback function to retrieve coding rate of
+   *        this WifiMode. If convolutional coding is used for this rate
+   *        then the callback returns the convolutional coding rate used. If
+   *        there is no explicit convolutional coding step (e.g., for DSSS
+   *        rates) then the callback should returns WIFI_CODE_RATE_UNDEFINED.
+   * \param constellationSizeCallback a callback function that returns the
+   *        order of the constellation used.
+   * \param phyRateCallback a callback function to calculate the PHY rate (in
+   *        bps) of this WifiMode.
+   * \param phyRateFromTxVectorCallback a callback function to calculate the PHY rate
+   *        (in bps) of this WifiMode using a TXVECTOR as input.
+   * \param dataRateCallback a callback function to calculate the data rate
+   *        (in bps) of this WifiMode.
+   * \param dataRateFromTxVectorCallback a callback function to calculate the data rate
+   *        (in bps) of this WifiMode using a TXVECTOR as input.
+   * \param isModeAllowedCallback a callback function to check whether a
+   *        specific combination of this WifiMode, channel width (MHz), and
+   *        NSS are allowed.
    *
    * \return WifiMode
    *
@@ -317,22 +364,52 @@
   static WifiMode CreateWifiMode (std::string uniqueName,
                                   WifiModulationClass modClass,
                                   bool isMandatory,
-                                  WifiCodeRate codingRate,
-                                  uint16_t constellationSize);
+                                  CodeRateCallback codeRateCallback,
+                                  ConstellationSizeCallback constellationSizeCallback,
+                                  PhyRateCallback phyRateCallback,
+                                  PhyRateFromTxVectorCallback phyRateFromTxVectorCallback,
+                                  DataRateCallback dataRateCallback,
+                                  DataRateFromTxVectorCallback dataRateFromTxVectorCallback,
+                                  ModeAllowedCallback isModeAllowedCallback);
 
   /**
    * \param uniqueName the name of the associated WifiMode. This name
    *        must be unique across _all_ instances.
    * \param mcsValue the MCS value
    * \param modClass the class of modulation
+   * \param codeRateCallback a callback function that returns the coding rate
+   *        of this WifiMode.
+   * \param constellationSizeCallback a callback function that returns the size
+   *        of modulation constellation of this WifiMode.
+   * \param phyRateCallback a callback function to calculate the PHY rate (in
+   *        bps) of this WifiMode.
+   * \param phyRateFromTxVectorCallback a callback function to calculate the PHY rate
+   *        (in bps) of this WifiMode using a TXVECTOR as input.
+   * \param dataRateCallback a callback function to calculate the data rate (in
+   *        bps) of this WifiMode.
+   * \param dataRateFromTxVectorCallback a callback function to calculate the data rate
+   *        (in bps) of this WifiMode using a TXVECTOR as input.
+   * \param nonHtReferenceRateCallback a callback function to calculate the rate
+   *        (in bps) of the non-HT Reference Rate of this WifiMode.
+   * \param isModeAllowedCallback a callback function to calculate whether a
+   *        combination of <MCS index, channel width (MHz), number of spatial
+   *        stream> is allowed for this WifiMode.
    *
    * \return WifiMode
    *
-   * Create a HT WifiMode.
+   * Create a HT or later WifiMode.
    */
   static WifiMode CreateWifiMcs (std::string uniqueName,
                                  uint8_t mcsValue,
-                                 WifiModulationClass modClass);
+                                 WifiModulationClass modClass,
+                                 CodeRateCallback codeRateCallback,
+                                 ConstellationSizeCallback constellationSizeCallback,
+                                 PhyRateCallback phyRateCallback,
+                                 PhyRateFromTxVectorCallback phyRateFromTxVectorCallback,
+                                 DataRateCallback dataRateCallback,
+                                 DataRateFromTxVectorCallback dataRateFromTxVectorCallback,
+                                 NonHtReferenceRateCallback nonHtReferenceRateCallback,
+                                 ModeAllowedCallback isModeAllowedCallback);
 
 
 private:
@@ -355,12 +432,18 @@
    */
   struct WifiModeItem
   {
-    std::string uniqueUid; ///< unique UID
+    std::string uniqueUid;        ///< unique UID
     WifiModulationClass modClass; ///< modulation class
-    uint16_t constellationSize; ///< constellation size
-    WifiCodeRate codingRate; ///< coding rate
-    bool isMandatory; ///< flag to indicate whether this mode is mandatory
-    uint8_t mcsValue; ///< MCS value
+    bool isMandatory;             ///< flag to indicate whether this mode is mandatory
+    uint8_t mcsValue;             ///< MCS value
+    CodeRateCallback GetCodeRateCallback;                         ///< Callback to retrieve code rate of this WifiModeItem
+    ConstellationSizeCallback GetConstellationSizeCallback;       ///< Callback to retrieve constellation size of this WifiModeItem
+    PhyRateCallback GetPhyRateCallback;                           ///< Callback to calculate PHY rate in bps of this WifiModeItem
+    PhyRateFromTxVectorCallback GetPhyRateFromTxVectorCallback;   ///< Callback to calculate PHY rate in bps of this WifiModeItem using a TXVECTOR as input
+    DataRateCallback GetDataRateCallback;                         ///< Callback to calculate data rate in bps of this WifiModeItem
+    DataRateFromTxVectorCallback GetDataRateFromTxVectorCallback; ///< Callback to calculate data rate in bps of this WifiModeItem using a TXVECTOR as input
+    NonHtReferenceRateCallback GetNonHtReferenceRateCallback;     ///< Callback to calculate non-HT reference rate of this WifiModeItem
+    ModeAllowedCallback IsModeAllowedCallback;                    ///< Callback to check whether the combination of <MCS, channel width (MHz), NSS> is allowed
   };
 
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-net-device.cc ns-3.34/src/wifi/model/wifi-net-device.cc
--- ns-3.33/src/wifi/model/wifi-net-device.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-net-device.cc	2021-07-14 10:31:07.000000000 -0700
@@ -27,9 +27,9 @@
 #include "wifi-net-device.h"
 #include "wifi-phy.h"
 #include "wifi-mac.h"
-#include "ht-configuration.h"
-#include "vht-configuration.h"
-#include "he-configuration.h"
+#include "ns3/ht-configuration.h"
+#include "ns3/vht-configuration.h"
+#include "ns3/he-configuration.h"
 
 namespace ns3 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-net-device.h ns-3.34/src/wifi/model/wifi-net-device.h
--- ns-3.33/src/wifi/model/wifi-net-device.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-net-device.h	2021-07-14 10:31:07.000000000 -0700
@@ -112,36 +112,35 @@
    */
   Ptr<HeConfiguration> GetHeConfiguration (void) const;
 
-  //inherited from NetDevice base class.
-  void SetIfIndex (const uint32_t index);
-  uint32_t GetIfIndex (void) const;
-  Ptr<Channel> GetChannel (void) const;
-  void SetAddress (Address address);
-  Address GetAddress (void) const;
-  bool SetMtu (const uint16_t mtu);
-  uint16_t GetMtu (void) const;
-  bool IsLinkUp (void) const;
-  void AddLinkChangeCallback (Callback<void> callback);
-  bool IsBroadcast (void) const;
-  Address GetBroadcast (void) const;
-  bool IsMulticast (void) const;
-  Address GetMulticast (Ipv4Address multicastGroup) const;
-  bool IsPointToPoint (void) const;
-  bool IsBridge (void) const;
-  bool Send (Ptr<Packet> packet, const Address& dest, uint16_t protocolNumber);
-  Ptr<Node> GetNode (void) const;
-  void SetNode (const Ptr<Node> node);
-  bool NeedsArp (void) const;
-  void SetReceiveCallback (NetDevice::ReceiveCallback cb);
-  Address GetMulticast (Ipv6Address addr) const;
-  bool SendFrom (Ptr<Packet> packet, const Address& source, const Address& dest, uint16_t protocolNumber);
-  void SetPromiscReceiveCallback (PromiscReceiveCallback cb);
-  bool SupportsSendFrom (void) const;
+  void SetIfIndex (const uint32_t index) override;
+  uint32_t GetIfIndex (void) const override;
+  Ptr<Channel> GetChannel (void) const override;
+  void SetAddress (Address address) override;
+  Address GetAddress (void) const override;
+  bool SetMtu (const uint16_t mtu) override;
+  uint16_t GetMtu (void) const override;
+  bool IsLinkUp (void) const override;
+  void AddLinkChangeCallback (Callback<void> callback) override;
+  bool IsBroadcast (void) const override;
+  Address GetBroadcast (void) const override;
+  bool IsMulticast (void) const override;
+  Address GetMulticast (Ipv4Address multicastGroup) const override;
+  bool IsPointToPoint (void) const override;
+  bool IsBridge (void) const override;
+  bool Send (Ptr<Packet> packet, const Address& dest, uint16_t protocolNumber) override;
+  Ptr<Node> GetNode (void) const override;
+  void SetNode (const Ptr<Node> node) override;
+  bool NeedsArp (void) const override;
+  void SetReceiveCallback (NetDevice::ReceiveCallback cb) override;
+  Address GetMulticast (Ipv6Address addr) const override;
+  bool SendFrom (Ptr<Packet> packet, const Address& source, const Address& dest, uint16_t protocolNumber) override;
+  void SetPromiscReceiveCallback (PromiscReceiveCallback cb) override;
+  bool SupportsSendFrom (void) const override;
 
 
 protected:
-  void DoDispose (void);
-  void DoInitialize (void);
+  void DoDispose (void) override;
+  void DoInitialize (void) override;
   /**
    * Receive a packet from the lower layer and pass the
    * packet up the stack.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-phy-band.h ns-3.34/src/wifi/model/wifi-phy-band.h
--- ns-3.33/src/wifi/model/wifi-phy-band.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-phy-band.h	2021-07-14 10:31:07.000000000 -0700
@@ -21,6 +21,8 @@
 #ifndef WIFI_PHY_BAND_H
 #define WIFI_PHY_BAND_H
 
+#include <iostream>
+
 namespace ns3 {
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-phy.cc ns-3.34/src/wifi/model/wifi-phy.cc
--- ns-3.33/src/wifi/model/wifi-phy.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-phy.cc	2021-07-14 10:31:07.000000000 -0700
@@ -35,10 +35,15 @@
 #include "wifi-radio-energy-model.h"
 #include "error-rate-model.h"
 #include "wifi-net-device.h"
-#include "ht-configuration.h"
-#include "he-configuration.h"
+#include "ns3/ht-configuration.h"
+#include "ns3/he-configuration.h"
 #include "mpdu-aggregator.h"
 #include "wifi-psdu.h"
+#include "wifi-ppdu.h"
+#include "ap-wifi-mac.h"
+#include "ns3/dsss-phy.h"
+#include "ns3/erp-ofdm-phy.h"
+#include "ns3/he-phy.h" //includes OFDM, HT, and VHT
 
 namespace ns3 {
 
